=== runners/CMakeLists.txt ===
if(KF5Baloo_FOUND)
 add_subdirectory(baloo)
endif()
add_subdirectory(bookmarks)
add_subdirectory(calculator)
add_subdirectory(helprunner)
add_subdirectory(locations)
add_subdirectory(places)
add_subdirectory(services)
add_subdirectory(recentdocuments)
add_subdirectory(shell)
add_subdirectory(webshortcuts)
add_subdirectory(windowedwidgets)

if(AppStreamQt_FOUND)
    add_subdirectory(appstream)
endif()

if(NOT WIN32)
 add_subdirectory(powerdevil)
 add_subdirectory(sessions)
 add_subdirectory(kill)
endif()
#
